import java.util.HashSet;

class GraphAdjMat implements IGraph{
	int[][] adjacency;
	public void setGraph(int[] vertices, Edge[] edges){
		adjacency = new int[vertices.length][vertices.length];
		if (edges != null){
			for(Edge e : edges){
				adjacency[e.v1][e.v2] = 1;
				adjacency[e.v2][e.v1] = 1;
			}
		}
	}
	public int[] getVertices(){
		int[] res = new int[adjacency.length];
		for(int i = 0; i < res.length; i++)
			res[i] = i;
		return res;
	}
	public Edge[] getEdges(){
		HashSet<Edge> res = new HashSet<Edge>();
		for(int i = 0; i < adjacency.length; i++){
			for(int j = i+1; j < adjacency.length; j++){
				if (adjacency[i][j] == 1)
					res.add(new Edge(i,j));
			}
		}
		if (res.size() > 0)
			return res.toArray(new Edge[res.size()]);
		return null;
	}
	public boolean isAdjacent(int v1, int v2){
		return adjacency[v1][v2] == 1;
	}
	public int getDegree(int vertex){
		int result = 0;
		for(int i = 0; i < adjacency.length; i++)
			if (adjacency[vertex][i] == 1)
				result++;
		return result;
	}
	public int getSize(){
		return adjacency.length*adjacency.length*4;
	}
}